Data Structures | Enumerations | Functions | Variables

# newgrf_debug.h File Reference

Functions/types related to NewGRF debugging. More...

`#include "newgrf.h"`
`#include "core/smallvec_type.hpp"`
`#include "tile_type.h"`
`#include "vehicle_type.h"`

Go to the source code of this file.

## Data Structures
struct | NewGrfDebugSpritePicker
| Spritepicker of SpriteAligner. More...
## Enumerations
enum | NewGrfDebugSpritePickerMode { SPM_NONE, SPM_WAIT_CLICK, SPM_REDRAW }
| Current state of spritepicker.
## Functions
bool | IsNewGRFInspectable (GrfSpecFeature feature, uint index)
| Can we inspect the data given a certain feature and index.
void | ShowNewGRFInspectWindow (GrfSpecFeature feature, uint index, const uint32 grfid=0)
| Show the inspect window for a given feature and index.
void | DeleteNewGRFInspectWindow (GrfSpecFeature feature, uint index)
| Delete inspect window for a given feature and index.
GrfSpecFeature | GetGrfSpecFeature (TileIndex tile)
| Get the GrfSpecFeature associated with the tile.
GrfSpecFeature | GetGrfSpecFeature (VehicleType type)
| Get the GrfSpecFeature associated with the vehicle.
void | ShowSpriteAlignerWindow ()
| Show the window for aligning sprites.
## Variables
NewGrfDebugSpritePicker | _newgrf_debug_sprite_picker
| The sprite picker.

## Detailed Description

Functions/types related to NewGRF debugging.

Definition in file newgrf_debug.h.

## Function Documentation

void DeleteNewGRFInspectWindow | ( | GrfSpecFeature | feature,
|  | uint | index |
| ) |  |  |

Delete inspect window for a given feature and index.

The index is normally an in-game location/identifier, such as a TileIndex or an IndustryID depending on the feature we want to inspect.

Parameters:

  | feature | The feature we want to delete the window for.
  | index | The index/identifier of the feature to delete.

Definition at line 555 of file newgrf_debug_gui.cpp.

References DeleteWindowById(), GetInspectWindowNumber(), GSF_INVALID, InvalidateWindowData(), WC_LAND_INFO, and WC_NEWGRF_INSPECT.

Referenced by CmdRemoveSingleRail(), DoClearTownHouseHelper(), ReallyClearObjectTile(), RemoveAirport(), RemoveFromRailBaseStation(), RemoveRailStation(), Town::~Town(), and Vehicle::~Vehicle().

GrfSpecFeature GetGrfSpecFeature | ( | TileIndex | tile | ) |

Get the GrfSpecFeature associated with the tile.

Parameters:

  | tile | The tile to get the feature from.

Returns:
  the GrfSpecFeature.

Definition at line 589 of file newgrf_debug_gui.cpp.

References GetStationType(), GetTileType(), IsLevelCrossing(), MP_HOUSE, MP_INDUSTRY, MP_OBJECT, MP_RAILWAY, MP_ROAD, and MP_STATION.

Referenced by NIHVehicle::GetParent(), VehicleViewWindow::IsNewGRFInspectable(), LandInfoWindow::IsNewGRFInspectable(), VehicleViewWindow::ShowNewGRFInspectWindow(), LandInfoWindow::ShowNewGRFInspectWindow(), and Vehicle::~Vehicle().

GrfSpecFeature GetGrfSpecFeature | ( | VehicleType | type | ) |

Get the GrfSpecFeature associated with the vehicle.

Parameters:

  | type | The vehicle type to get the feature from.

Returns:
  the GrfSpecFeature.

Definition at line 613 of file newgrf_debug_gui.cpp.

References VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, and VEH_TRAIN.

bool IsNewGRFInspectable | ( | GrfSpecFeature | feature,
|  | uint | index |
| ) |  |  |

Can we inspect the data given a certain feature and index.

The index is normally an in-game location/identifier, such as a TileIndex or an IndustryID depending on the feature we want to inspect.

Parameters:

  | feature | The feature we want to inspect.
  | index | The index/identifier of the feature to inspect.

Returns:
  true if there is something to show.

Definition at line 577 of file newgrf_debug_gui.cpp.

References GetFeature(), GetInspectWindowNumber(), NIFeature::helper, and NIHelper::IsInspectable().

Referenced by VehicleViewWindow::IsNewGRFInspectable(), and ShowNewGRFInspectWindow().

void ShowNewGRFInspectWindow | ( | GrfSpecFeature | feature,
|  | uint | index,
|  | const uint32 | grfid |
| ) |  |  |

Show the inspect window for a given feature and index.

The index is normally an in-game location/identifier, such as a TileIndex or an IndustryID depending on the feature we want to inspect.

Parameters:

  | feature | The feature we want to inspect.
  | index | The index/identifier of the feature to inspect.
  | grfid | GRFID of the item opening this window, or 0 if not opened by other window.

Definition at line 537 of file newgrf_debug_gui.cpp.

References FindWindowById(), GetInspectWindowNumber(), IsNewGRFInspectable(), NewGRFInspectWindow::SetCallerGRFID(), and WC_NEWGRF_INSPECT.

Referenced by VehicleViewWindow::ShowNewGRFInspectWindow().

## Variable Documentation

NewGrfDebugSpritePicker _newgrf_debug_sprite_picker

The sprite picker.

Definition at line 44 of file newgrf_debug_gui.cpp.

Referenced by HandleMouseEvents().